package com.blamejared.compat.botania.commands;

import com.blamejared.mtlib.helpers.LogHelper;
import com.blamejared.mtlib.helpers.StringHelper;
import com.google.common.collect.ImmutableList;
import crafttweaker.CraftTweakerAPI;
import crafttweaker.mc1120.commands.CraftTweakerCommand;
import crafttweaker.mc1120.commands.SpecialMessagesChat;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import net.minecraft.command.ICommandSender;
import net.minecraft.item.ItemStack;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.text.TextComponentString;
import vazkii.botania.api.BotaniaAPI;
import vazkii.botania.api.recipe.RecipeBrew;
import vazkii.botania.api.recipe.RecipeElvenTrade;
import vazkii.botania.api.recipe.RecipeManaInfusion;
import vazkii.botania.api.recipe.RecipePetals;
import vazkii.botania.api.recipe.RecipePureDaisy;
import vazkii.botania.api.recipe.RecipeRuneAltar;

public class BotaniaLogger extends CraftTweakerCommand {
   private static final List<String> ARGS = ImmutableList.of("apothecary", "brews", "trades", "infusions", "daisy", "altar");

   public BotaniaLogger() {
      super("botania");
   }

   public void executeCommand(MinecraftServer server, ICommandSender sender, String[] arguments) {
      List<String> args = Arrays.asList(arguments);
      Iterator var5;
      if (args.contains("apothecary")) {
         var5 = BotaniaAPI.petalRecipes.iterator();

         while(var5.hasNext()) {
            RecipePetals recipe = (RecipePetals)var5.next();
            CraftTweakerAPI.logCommand("Botania Apothecary Recipes");
            CraftTweakerAPI.logCommand(String.format("mods.botania.Apothecary.addRecipe(%s, %s);", LogHelper.getStackDescription(recipe.getOutput()), LogHelper.getListDescription(recipe.getInputs())));
         }
      } else if (args.contains("brews")) {
         var5 = BotaniaAPI.brewRecipes.iterator();

         while(var5.hasNext()) {
            RecipeBrew recipe = (RecipeBrew)var5.next();
            CraftTweakerAPI.logCommand("Botania Brewing Recipes");
            CraftTweakerAPI.logCommand(String.format("mods.botania.Brew.addRecipe(%s, \"%s\");", LogHelper.getListDescription(recipe.getInputs()), recipe.getBrew().getKey()));
         }
      } else if (args.contains("trades")) {
         var5 = BotaniaAPI.elvenTradeRecipes.iterator();

         while(var5.hasNext()) {
            RecipeElvenTrade recipe = (RecipeElvenTrade)var5.next();
            CraftTweakerAPI.logCommand("Botania Trading Recipes");
            CraftTweakerAPI.logCommand(String.format("mods.botania.ElvenTrade.addRecipe(%s, %s);", LogHelper.getStackDescription(recipe.getOutputs()), LogHelper.getListDescription(recipe.getInputs())));
         }
      } else if (args.contains("infusions")) {
         var5 = BotaniaAPI.manaInfusionRecipes.iterator();

         while(var5.hasNext()) {
            RecipeManaInfusion recipe = (RecipeManaInfusion)var5.next();
            CraftTweakerAPI.logCommand("Botania Infusion Recipes");
            CraftTweakerAPI.logCommand(String.format("mods.botania.ManaInfusion.add%s(%s, %s, %d);", recipe.isAlchemy() ? "Alchemy" : (recipe.isConjuration() ? "Conjuration" : "Infusion"), LogHelper.getStackDescription(recipe.getOutput()), LogHelper.getStackDescription(recipe.getInput()), recipe.getManaToConsume()));
         }
      } else if (args.contains("daisy")) {
         var5 = BotaniaAPI.pureDaisyRecipes.iterator();

         while(var5.hasNext()) {
            RecipePureDaisy recipe = (RecipePureDaisy)var5.next();
            CraftTweakerAPI.logCommand("Botania Daisy Recipes");
            CraftTweakerAPI.logCommand(String.format("mods.botania.PureDaisy.addRecipe(%s, %s);", LogHelper.getStackDescription(recipe.getInput()), LogHelper.getStackDescription(new ItemStack(recipe.getOutputState().func_177230_c(), 1))));
         }
      } else {
         if (!args.contains("altar")) {
            if (sender != null) {
               sender.func_145747_a(new TextComponentString("Invalid arguments for command. Valid arguments: " + StringHelper.join(ARGS, ", ")));
            }

            return;
         }

         var5 = BotaniaAPI.runeAltarRecipes.iterator();

         while(var5.hasNext()) {
            RecipeRuneAltar recipe = (RecipeRuneAltar)var5.next();
            CraftTweakerAPI.logCommand("Botania Altar Recipes");
            CraftTweakerAPI.logCommand(String.format("mods.botania.RuneAltar.addRecipe(%s, %s, %d);", LogHelper.getStackDescription(recipe.getOutput()), LogHelper.getListDescription(recipe.getInputs()), recipe.getManaUsage()));
         }
      }

      if (sender != null) {
         sender.func_145747_a(SpecialMessagesChat.getLinkToCraftTweakerLog("List generated;", sender));
      }

   }

   protected void init() {
   }
}
